#ifndef ACTOR_BODY_H
#define ACTOR_BODY_H

#include "scene/3d/physics/character_body_3d.h"

class ActorBody : public CharacterBody3D {
	GDCLASS(ActorBody, CharacterBody3D);
	static void _bind_methods();
	void physics_process(double delta);

public:
	// support both directional and positional movement modes
	enum MovementMode {
		Direction,
		Position
	};
	void _notification(int what);

	void set_movement_direction(Vector3 direction);
	Vector3 get_movement_direction() const;
	void set_movement_target(Vector3 location);
	Vector3 get_movement_target() const;
	void teleport(Vector3 target);

	void set_movement_speed(float speed);
	float get_movement_speed() const;
	MovementMode get_movement_mode() const;

private:
	float movement_speed{ 3.f };
	Vector3 movement_vector{ 0.f, 0.f, 0.f };
	MovementMode mode{ Direction };
	bool teleport_on_process{ false };
	Vector3 teleport_target{};
};

#endif //! ACTOR_BODY_H
