#ifndef PLAYER_INPUT_H
#define PLAYER_INPUT_H

#include "core/input/input_event.h"
#include "scene/main/node.h"

class PlayerInput : public Node {
	GDCLASS(PlayerInput, Node);
	static void _bind_methods();

public:
	void _notification(int what);
	virtual void unhandled_input(Ref<InputEvent> const &event) override;

	void set_mouselook_speed(Vector2 speed);
	Vector2 get_mouselook_speed() const;
	void set_look_speed(Vector2 speed);
	Vector2 get_look_speed() const;

	void set_action_move_left(String action);
	String get_action_move_left() const;
	void set_action_move_right(String action);
	String get_action_move_right() const;
	void set_action_move_forward(String action);
	String get_action_move_forward() const;
	void set_action_move_back(String action);
	String get_action_move_back() const;

	void set_action_look_left(String action);
	String get_action_look_left() const;
	void set_action_look_right(String action);
	String get_action_look_right() const;
	void set_action_look_up(String action);
	String get_action_look_up() const;
	void set_action_look_down(String action);
	String get_action_look_down() const;

public:
	static String const signal_movement;
	static String const signal_look;
	static String const signal_mouselook;

private:
	Vector2 mouselook_speed{ 0.001f, 0.001f };
	Vector2 look_speed{ 1.75f, 1.75f };

	String action_move_left{ "move_left" };
	String action_move_right{ "move_right" };
	String action_move_forward{ "move_forward" };
	String action_move_back{ "move_back" };

	String action_look_left{ "look_left" };
	String action_look_right{ "look_right" };
	String action_look_up{ "look_up" };
	String action_look_down{ "look_down" };
};

#endif // !PLAYER_INPUT_H
