#ifndef THIRD_PERSON_CAMERA_H
#define THIRD_PERSON_CAMERA_H

#include "scene/3d/camera_3d.h"

class ThirdPersonCamera : public Camera3D {
	GDCLASS(ThirdPersonCamera, Camera3D);
	static void _bind_methods();
	void ready();
	void process(double delta);
	void on_look_input(Vector2 input);
	void on_mouselook_input(Vector2 input);

public:
	void _notification(int what);

	void set_base_rotation_speed(Vector2 value);
	Vector2 get_base_rotation_speed() const;

private:
	Vector2 look_rotation_motion{ 0.f, 0.f };
	Vector2 look_rotation{ 0.f, 0.f };

	Vector2 base_rotation_speed{ 0.1f, 0.1f };
	float distance{ 3.f };
	float height{ 2.2f };
};

#endif // !THIRD_PERSON_CAMERA_H
